OGRE-Next: Ogre::GpuProgramParameters Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Static Public Member Functions | List of all members
Ogre::GpuProgramParameters Class Reference
Core » Materials

Collects together the program parameters used for a GpuProgram. More...

`#include <OgreGpuProgramParams.h>`

Inheritance diagram for Ogre::GpuProgramParameters:
[legend]

## Classes
struct | AutoConstantDefinition
| Structure defining an auto constant that's available for use in a parameters object. More...

## Public Types
enum | ACDataType { ACDT_NONE , ACDT_INT , ACDT_REAL }
| Defines the type of the extra data item used by the auto constant. More...
typedef ConstVectorIterator< AutoConstantList > | AutoConstantIterator
typedef vector< GpuProgramParameters_AutoConstantEntry >::type | AutoConstantList
enum | AutoConstantType { ACT_WORLD_MATRIX , ACT_INVERSE_WORLD_MATRIX , ACT_TRANSPOSE_WORLD_MATRIX , ACT_INVERSE_TRANSPOSE_WORLD_MATRIX , ACT_WORLD_MATRIX_ARRAY_3x4 , ACT_WORLD_MATRIX_ARRAY , ACT_WORLD_DUALQUATERNION_ARRAY_2x4 , ACT_WORLD_SCALE_SHEAR_MATRIX_ARRAY_3x4 , ACT_VIEW_MATRIX , ACT_INVERSE_VIEW_MATRIX , ACT_TRANSPOSE_VIEW_MATRIX , ACT_INVERSE_TRANSPOSE_VIEW_MATRIX , ACT_PROJECTION_MATRIX , ACT_INVERSE_PROJECTION_MATRIX , ACT_TRANSPOSE_PROJECTION_MATRIX , ACT_INVERSE_TRANSPOSE_PROJECTION_MATRIX , ACT_VIEWPROJ_MATRIX , ACT_INVERSE_VIEWPROJ_MATRIX , ACT_TRANSPOSE_VIEWPROJ_MATRIX , ACT_INVERSE_TRANSPOSE_VIEWPROJ_MATRIX , ACT_WORLDVIEW_MATRIX , ACT_INVERSE_WORLDVIEW_MATRIX , ACT_TRANSPOSE_WORLDVIEW_MATRIX , ACT_INVERSE_TRANSPOSE_WORLDVIEW_MATRIX , ACT_WORLDVIEWPROJ_MATRIX , ACT_INVERSE_WORLDVIEWPROJ_MATRIX , ACT_TRANSPOSE_WORLDVIEWPROJ_MATRIX , ACT_INVERSE_TRANSPOSE_WORLDVIEWPROJ_MATRIX , ACT_RENDER_TARGET_FLIPPING , ACT_VERTEX_WINDING , ACT_FOG_COLOUR , ACT_FOG_PARAMS , ACT_SURFACE_AMBIENT_COLOUR , ACT_SURFACE_DIFFUSE_COLOUR , ACT_SURFACE_SPECULAR_COLOUR , ACT_SURFACE_EMISSIVE_COLOUR , ACT_SURFACE_SHININESS , ACT_SURFACE_ALPHA_REJECTION_VALUE , ACT_LIGHT_COUNT , ACT_AMBIENT_LIGHT_COLOUR , ACT_LIGHT_DIFFUSE_COLOUR , ACT_LIGHT_SPECULAR_COLOUR , ACT_LIGHT_ATTENUATION , ACT_SPOTLIGHT_PARAMS , ACT_LIGHT_POSITION , ACT_LIGHT_POSITION_OBJECT_SPACE , ACT_LIGHT_POSITION_VIEW_SPACE , ACT_LIGHT_DIRECTION , ACT_LIGHT_DIRECTION_OBJECT_SPACE , ACT_LIGHT_DIRECTION_VIEW_SPACE , ACT_LIGHT_DISTANCE_OBJECT_SPACE , ACT_LIGHT_POWER_SCALE , ACT_LIGHT_DIFFUSE_COLOUR_POWER_SCALED , ACT_LIGHT_SPECULAR_COLOUR_POWER_SCALED , ACT_LIGHT_DIFFUSE_COLOUR_ARRAY , ACT_LIGHT_SPECULAR_COLOUR_ARRAY , ACT_LIGHT_DIFFUSE_COLOUR_POWER_SCALED_ARRAY , ACT_LIGHT_SPECULAR_COLOUR_POWER_SCALED_ARRAY , ACT_LIGHT_ATTENUATION_ARRAY , ACT_LIGHT_POSITION_ARRAY , ACT_LIGHT_POSITION_OBJECT_SPACE_ARRAY , ACT_LIGHT_POSITION_VIEW_SPACE_ARRAY , ACT_LIGHT_DIRECTION_ARRAY , ACT_LIGHT_DIRECTION_OBJECT_SPACE_ARRAY , ACT_LIGHT_DIRECTION_VIEW_SPACE_ARRAY , ACT_LIGHT_DISTANCE_OBJECT_SPACE_ARRAY , ACT_LIGHT_POWER_SCALE_ARRAY , ACT_SPOTLIGHT_PARAMS_ARRAY , ACT_DERIVED_AMBIENT_LIGHT_COLOUR , ACT_DERIVED_SCENE_COLOUR , ACT_DERIVED_LIGHT_DIFFUSE_COLOUR , ACT_DERIVED_LIGHT_SPECULAR_COLOUR , ACT_DERIVED_LIGHT_DIFFUSE_COLOUR_ARRAY , ACT_DERIVED_LIGHT_SPECULAR_COLOUR_ARRAY , ACT_LIGHT_CASTS_SHADOWS , ACT_LIGHT_CASTS_SHADOWS_ARRAY , ACT_SHADOW_EXTRUSION_DISTANCE , ACT_CAMERA_POSITION , ACT_CAMERA_POSITION_OBJECT_SPACE , ACT_TEXTURE_VIEWPROJ_MATRIX , ACT_TEXTURE_VIEWPROJ_MATRIX_ARRAY , ACT_TEXTURE_WORLDVIEWPROJ_MATRIX , ACT_TEXTURE_WORLDVIEWPROJ_MATRIX_ARRAY , ACT_SPOTLIGHT_VIEWPROJ_MATRIX , ACT_SPOTLIGHT_VIEWPROJ_MATRIX_ARRAY , ACT_SPOTLIGHT_WORLDVIEWPROJ_MATRIX , ACT_SPOTLIGHT_WORLDVIEWPROJ_MATRIX_ARRAY , ACT_RS_DEPTH_RANGE , ACT_CUSTOM , ACT_TIME , ACT_TIME_0_X , ACT_COSTIME_0_X , ACT_SINTIME_0_X , ACT_TANTIME_0_X , ACT_TIME_0_X_PACKED , ACT_TIME_0_1 , ACT_COSTIME_0_1 , ACT_SINTIME_0_1 , ACT_TANTIME_0_1 , ACT_TIME_0_1_PACKED , ACT_TIME_0_2PI , ACT_COSTIME_0_2PI , ACT_SINTIME_0_2PI , ACT_TANTIME_0_2PI , ACT_TIME_0_2PI_PACKED , ACT_FRAME_TIME , ACT_FPS , ACT_VIEWPORT_WIDTH , ACT_VIEWPORT_HEIGHT , ACT_INVERSE_VIEWPORT_WIDTH , ACT_INVERSE_VIEWPORT_HEIGHT , ACT_VIEWPORT_SIZE , ACT_VIEW_DIRECTION , ACT_VIEW_SIDE_VECTOR , ACT_VIEW_UP_VECTOR , ACT_FOV , ACT_NEAR_CLIP_DISTANCE , ACT_FAR_CLIP_DISTANCE , ACT_PASS_NUMBER , ACT_PASS_ITERATION_NUMBER , ACT_ANIMATION_PARAMETRIC , ACT_TEXEL_OFFSETS , ACT_SCENE_DEPTH_RANGE , ACT_SHADOW_SCENE_DEPTH_RANGE , ACT_SHADOW_SCENE_DEPTH_RANGE_ARRAY , ACT_SHADOW_COLOUR , ACT_UAV_SIZE , ACT_INVERSE_UAV_SIZE , ACT_PACKED_UAV_SIZE , ACT_TEXTURE_SIZE , ACT_INVERSE_TEXTURE_SIZE , ACT_PACKED_TEXTURE_SIZE , ACT_TEXTURE_MATRIX , ACT_LOD_CAMERA_POSITION , ACT_LOD_CAMERA_POSITION_OBJECT_SPACE , ACT_LIGHT_CUSTOM , ACT_PSSM_SPLITS , ACT_PSSM_BLENDS , ACT_PSSM_FADE , ACT_UNKNOWN = 999 }
| Defines the types of automatically updated values that may be bound to GpuProgram parameters, or used to modify parameters on a per-object basis. More...
enum | ElementType { ET_INT , ET_REAL }
| Defines the base element type of the auto constant. More...
typedef vector< GpuSharedParametersUsage >::type | GpuSharedParamUsageList
typedef unordered_map< size_t, String >::const_iterator | SubroutineIterator
typedef unordered_map< size_t, String >::type | SubroutineMap

## Public Member Functions
| GpuProgramParameters ()
| GpuProgramParameters (const GpuProgramParameters &oth)
| Copy constructor.
| ~GpuProgramParameters ()=default
void | _copySharedParams ()
| Update the parameters by copying the data from the shared parameters.
const GpuConstantDefinition * | _findNamedConstantDefinition (const String &name, bool throwExceptionIfMissing=false) const
| Find a constant definition for a named parameter.
const GpuProgramParameters_AutoConstantEntry * | _findRawAutoConstantEntryBool (size_t physicalIndex)
| Finds an auto constant that's affecting a given physical position in the boolean buffer.
const GpuProgramParameters_AutoConstantEntry * | _findRawAutoConstantEntryDouble (size_t physicalIndex)
| Finds an auto constant that's affecting a given physical position in the double-point buffer.
const GpuProgramParameters_AutoConstantEntry * | _findRawAutoConstantEntryFloat (size_t physicalIndex)
| Finds an auto constant that's affecting a given physical position in the floating-point buffer.
const GpuProgramParameters_AutoConstantEntry * | _findRawAutoConstantEntryInt (size_t physicalIndex)
| Finds an auto constant that's affecting a given physical position in the integer buffer.
const GpuProgramParameters_AutoConstantEntry * | _findRawAutoConstantEntryUnsignedInt (size_t physicalIndex)
| Finds an auto constant that's affecting a given physical position in the unsigned integer buffer.
size_t | _getDoubleConstantPhysicalIndex (size_t logicalIndex, size_t requestedSize, uint16 variability)
| Gets the physical buffer index associated with a logical double constant index.
size_t | _getFloatConstantPhysicalIndex (size_t logicalIndex, size_t requestedSize, uint16 variability)
| Gets the physical buffer index associated with a logical float constant index.
size_t | _getIntConstantPhysicalIndex (size_t logicalIndex, size_t requestedSize, uint16 variability)
| Gets the physical buffer index associated with a logical int constant index.
size_t | _getUnsignedIntConstantPhysicalIndex (size_t logicalIndex, size_t requestedSize, uint16 variability)
| Gets the physical buffer index associated with a logical unsigned int constant index.
void | _readRawConstants (size_t physicalIndex, size_t count, float *dest)
| Write a series of boolean values into the underlying integer constant buffer at the given physical index.
void | _readRawConstants (size_t physicalIndex, size_t count, int *dest)
| Read a series of integer values from the underlying integer constant buffer at the given physical index.
void | _setLogicalIndexes (const GpuLogicalBufferStructPtr &floatIndexMap, const GpuLogicalBufferStructPtr &doubleIndexMap, const GpuLogicalBufferStructPtr &intIndexMap, const GpuLogicalBufferStructPtr &uintIndexMap, const GpuLogicalBufferStructPtr &boolIndexMap)
| Internal method for providing a link to a logical index->physical index map for parameters.
void | _setNamedConstants (const GpuNamedConstantsPtr &constantmap)
| Internal method for providing a link to a name->definition map for parameters.
void | _setRawAutoConstant (size_t physicalIndex, AutoConstantType acType, size_t extraInfo, uint16 variability, size_t elementSize=4)
| As setAutoConstant, but sets up the auto constant directly against a physical buffer index.
void | _setRawAutoConstantReal (size_t physicalIndex, AutoConstantType acType, Real rData, uint16 variability, size_t elementSize=4)
| As setAutoConstantReal, but sets up the auto constant directly against a physical buffer index.
void | _updateAutoParams (const AutoParamDataSource *source, uint16 variabilityMask)
| Update automatic parameters.
void | _writeRawConstant (size_t physicalIndex, bool val)
| Write a single boolean parameter to the program.
void | _writeRawConstant (size_t physicalIndex, const ColourValue &colour, size_t count=4)
| Write a ColourValue parameter to the program.
void | _writeRawConstant (size_t physicalIndex, const Matrix4 &m, size_t elementCount)
| Write a Matrix4 parameter to the program.
void | _writeRawConstant (size_t physicalIndex, const Matrix4 *m, size_t numEntries)
| Write a list of Matrix4 parameters to the program.
void | _writeRawConstant (size_t physicalIndex, const Vector2 &vec)
| Write a 2-element floating-point parameter to the program via Vector2.
void | _writeRawConstant (size_t physicalIndex, const Vector3 &vec)
| Write a 3-element floating-point parameter to the program via Vector3.
void | _writeRawConstant (size_t physicalIndex, const Vector4 &vec, size_t count=4)
| Write a 4-element floating-point parameter to the program directly to the underlying constants buffer.
void | _writeRawConstant (size_t physicalIndex, int val)
| Write a single integer parameter to the program.
void | _writeRawConstant (size_t physicalIndex, Real val)
| Write a single floating-point parameter to the program.
void | _writeRawConstant (size_t physicalIndex, Real val, size_t count)
| Write a variable number of floating-point parameters to the program.
void | _writeRawConstant (size_t physicalIndex, uint val)
| Write a single unsigned integer parameter to the program.
void | _writeRawConstants (size_t physicalIndex, const double *val, size_t count)
| Write a series of floating point values into the underlying float constant buffer at the given physical index.
void | _writeRawConstants (size_t physicalIndex, const float *val, size_t count)
| Write a series of floating point values into the underlying float constant buffer at the given physical index.
void | _writeRawConstants (size_t physicalIndex, const int *val, size_t count)
| Write a series of integer values into the underlying integer constant buffer at the given physical index.
void | _writeRawConstants (size_t physicalIndex, const uint *val, size_t count)
| Write a series of unsigned integer values into the underlying integer constant buffer at the given physical index.
void | addSharedParameters (const String &sharedParamsName)
| Use a set of shared parameters in this parameters object.
void | addSharedParameters (GpuSharedParametersPtr sharedParams)
| Use a set of shared parameters in this parameters object.
size_t | calculateSize () const
void | clearAutoConstant (size_t index)
| Unbind an auto constant so that the constant is manually controlled again.
void | clearAutoConstants ()
| Clears all the existing automatic constants.
void | clearNamedAutoConstant (const String &name)
| Unbind an auto constant so that the constant is manually controlled again.
void | copyConstantsFrom (const GpuProgramParameters &source)
| Copies the values of all constants (including auto constants) from another GpuProgramParameters object.
void | copyMatchingNamedConstantsFrom (const GpuProgramParameters &source)
| Copies the values of all matching named constants (including auto constants) from another GpuProgramParameters object.
const GpuProgramParameters_AutoConstantEntry * | findAutoConstantEntry (const String &paramName)
| Finds an auto constant that's affecting a given logical parameter index for boolean values.
const GpuProgramParameters_AutoConstantEntry * | findDoubleAutoConstantEntry (size_t logicalIndex)
| Finds an auto constant that's affecting a given logical parameter index for double-point values.
const GpuProgramParameters_AutoConstantEntry * | findFloatAutoConstantEntry (size_t logicalIndex)
| Finds an auto constant that's affecting a given logical parameter index for floating-point values.
const GpuProgramParameters_AutoConstantEntry * | findIntAutoConstantEntry (size_t logicalIndex)
| Finds an auto constant that's affecting a given logical parameter index for integer values.
const GpuProgramParameters_AutoConstantEntry * | findUnsignedIntAutoConstantEntry (size_t logicalIndex)
| Finds an auto constant that's affecting a given logical parameter index for unsigned integer values.
size_t | getAutoConstantCount () const
| Gets the number of int constants that have been set.
GpuProgramParameters_AutoConstantEntry * | getAutoConstantEntry (const size_t index)
| Gets a specific Auto Constant entry if index is in valid range otherwise returns a NULL.
AutoConstantIterator | getAutoConstantIterator () const
| Gets an iterator over the automatic constant bindings currently in place.
const AutoConstantList & | getAutoConstantList () const
| Get a reference to the list of auto constant bindings.
const GpuLogicalBufferStructPtr & | getBoolLogicalBufferStruct () const
| Get the current list of mappings from low-level logical param indexes to physical buffer locations in the integer buffer.
size_t | getBoolLogicalIndexForPhysicalIndex (size_t physicalIndex)
| Retrieves the logical index relating to a physical index in the bool buffer, for programs which support that (low-level programs and high-level programs which use logical parameter indexes).
const GpuConstantDefinition & | getConstantDefinition (const String &name) const
| Get a specific GpuConstantDefinition for a named parameter.
GpuConstantDefinitionIterator | getConstantDefinitionIterator () const
| Gets an iterator over the named GpuConstantDefinition instances as defined by the program for which these parameters exist.
const GpuNamedConstants & | getConstantDefinitions () const
| Get the full list of GpuConstantDefinition instances.
const DoubleConstantList & | getDoubleConstantList () const
| Get a reference to the list of double constants.
const GpuLogicalBufferStructPtr & | getDoubleLogicalBufferStruct () const
| Get the current list of mappings from low-level logical param indexes to physical buffer locations in the double buffer.
size_t | getDoubleLogicalIndexForPhysicalIndex (size_t physicalIndex)
| Retrieves the logical index relating to a physical index in the double buffer, for programs which support that (low-level programs and high-level programs which use logical parameter indexes).
double * | getDoublePointer (size_t pos)
| Get a pointer to the 'nth' item in the double buffer.
const double * | getDoublePointer (size_t pos) const
| Get a pointer to the 'nth' item in the double buffer.
const FloatConstantList & | getFloatConstantList () const
| Get a reference to the list of float constants.
const GpuLogicalBufferStructPtr & | getFloatLogicalBufferStruct () const
| Get the current list of mappings from low-level logical param indexes to physical buffer locations in the float buffer.
size_t | getFloatLogicalIndexForPhysicalIndex (size_t physicalIndex)
| Retrieves the logical index relating to a physical index in the float buffer, for programs which support that (low-level programs and high-level programs which use logical parameter indexes).
float * | getFloatPointer (size_t pos)
| Get a pointer to the 'nth' item in the float buffer.
const float * | getFloatPointer (size_t pos) const
| Get a pointer to the 'nth' item in the float buffer.
const IntConstantList & | getIntConstantList () const
| Get a reference to the list of int constants.
const GpuLogicalBufferStructPtr & | getIntLogicalBufferStruct () const
| Get the current list of mappings from low-level logical param indexes to physical buffer locations in the integer buffer.
size_t | getIntLogicalIndexForPhysicalIndex (size_t physicalIndex)
| Retrieves the logical index relating to a physical index in the int buffer, for programs which support that (low-level programs and high-level programs which use logical parameter indexes).
int * | getIntPointer (size_t pos)
| Get a pointer to the 'nth' item in the int buffer.
const int * | getIntPointer (size_t pos) const
| Get a pointer to the 'nth' item in the int buffer.
size_t | getPassIterationNumberIndex () const
| Get the physical buffer index of the pass iteration number constant.
const GpuSharedParamUsageList & | getSharedParameters () const
| Get the list of shared parameter sets.
const SubroutineMap & | getSubroutineMap () const
| Get map with.
bool | getTransposeMatrices () const
| Gets whether or not matrices are to be transposed when set.
const UnsignedIntConstantList & | getUnsignedIntConstantList () const
| Get a reference to the list of uint constants.
const GpuLogicalBufferStructPtr & | getUnsignedIntLogicalBufferStruct () const
| Get the current list of mappings from low-level logical param indexes to physical buffer locations in the integer buffer.
size_t | getUnsignedIntLogicalIndexForPhysicalIndex (size_t physicalIndex)
| Retrieves the logical index relating to a physical index in the uint buffer, for programs which support that (low-level programs and high-level programs which use logical parameter indexes).
uint * | getUnsignedIntPointer (size_t pos)
| Get a pointer to the 'nth' item in the uint buffer.
const uint * | getUnsignedIntPointer (size_t pos) const
| Get a pointer to the 'nth' item in the uint buffer.
bool | hasAutoConstants () const
| Returns true if this instance has any automatic constants.
bool | hasLogicalIndexedParameters () const
| Does this parameter set include logically indexed parameters?
bool | hasNamedParameters () const
| Does this parameter set include named parameters?
bool | hasPassIterationNumber () const
| Does this parameters object have a pass iteration number constant?
void | incPassIterationNumber ()
| increments the multipass number entry by 1 if it exists
bool | isUsingSharedParameters (const String &sharedParamsName) const
| Returns whether this parameter set is using the named shared parameter set.
GpuProgramParameters & | operator= (const GpuProgramParameters &oth)
| Operator = overload.
void | removeAllSharedParameters ()
| Stop using all shared parameter sets.
void | removeSharedParameters (const String &sharedParamsName)
| Stop using the named shared parameter set.
void | setAutoConstant (size_t index, AutoConstantType acType, size_t extraInfo=0)
| Sets up a constant which will automatically be updated by the system.
void | setAutoConstant (size_t index, AutoConstantType acType, uint16 extraInfo1, uint16 extraInfo2)
| Sets up a constant which will automatically be updated by the system.
void | setAutoConstantReal (size_t index, AutoConstantType acType, Real rData)
void | setConstant (size_t index, const bool *val, size_t count)
| Sets a multiple value constant boolean parameter to the program.
void | setConstant (size_t index, const ColourValue &colour)
| Sets a ColourValue parameter to the program.
void | setConstant (size_t index, const double *val, size_t count)
| Sets a multiple value constant floating-point parameter to the program.
void | setConstant (size_t index, const float *val, size_t count)
| Sets a multiple value constant floating-point parameter to the program.
void | setConstant (size_t index, const int *val, size_t count)
| Sets a multiple value constant integer parameter to the program.
void | setConstant (size_t index, const Matrix4 &m)
| Sets a Matrix4 parameter to the program.
void | setConstant (size_t index, const Matrix4 *m, size_t numEntries)
| Sets a list of Matrix4 parameters to the program.
void | setConstant (size_t index, const uint *val, size_t count)
| Sets a multiple value constant unsigned integer parameter to the program.
void | setConstant (size_t index, const Vector2 &vec)
| Sets a 4-element floating-point parameter to the program via Vector2.
void | setConstant (size_t index, const Vector3 &vec)
| Sets a 4-element floating-point parameter to the program via Vector3.
void | setConstant (size_t index, const Vector4 &vec)
| Sets a 4-element floating-point parameter to the program.
void | setConstant (size_t index, Real val)
| Sets a single floating-point parameter to the program.
void | setConstantFromTime (size_t index, Real factor)
| Sets a named parameter up to track a derivation of the current time.
void | setIgnoreMissingParams (bool state)
| Tells the program whether to ignore missing parameters or not.
void | setNamedAutoConstant (const String &name, AutoConstantType acType, size_t extraInfo=0)
| Sets a multiple value constant boolean parameter to the program.
void | setNamedAutoConstant (const String &name, AutoConstantType acType, uint16 extraInfo1, uint16 extraInfo2)
| Sets up a constant which will automatically be updated by the system.
void | setNamedAutoConstantReal (const String &name, AutoConstantType acType, Real rData)
void | setNamedConstant (const String &name, const ColourValue &colour)
| Sets a ColourValue parameter to the program.
void | setNamedConstant (const String &name, const double *val, size_t count, size_t multiple=4)
| Sets a multiple value constant floating-point parameter to the program.
void | setNamedConstant (const String &name, const float *val, size_t count, size_t multiple=4)
| Sets a multiple value constant floating-point parameter to the program.
void | setNamedConstant (const String &name, const int *val, size_t count, size_t multiple=4)
| Sets a multiple value constant integer parameter to the program.
void | setNamedConstant (const String &name, const Matrix3 &m)
void | setNamedConstant (const String &name, const Matrix4 &m)
| Sets a Matrix4 parameter to the program.
void | setNamedConstant (const String &name, const Matrix4 *m, size_t numEntries)
| Sets a list of Matrix4 parameters to the program.
void | setNamedConstant (const String &name, const uint *val, size_t count, size_t multiple=4)
| Sets a multiple value constant unsigned integer parameter to the program.
void | setNamedConstant (const String &name, const Vector2 &vec)
| Sets a Vector2 parameter to the program.
void | setNamedConstant (const String &name, const Vector3 &vec)
| Sets a Vector3 parameter to the program.
void | setNamedConstant (const String &name, const Vector4 &vec)
| Sets a single value constant boolean parameter to the program.
void | setNamedConstant (const String &name, int val)
| Sets a single value constant integer parameter to the program.
void | setNamedConstant (const String &name, Real val)
| Sets a single value constant floating-point parameter to the program.
void | setNamedConstant (const String &name, uint val)
| Sets a single value constant unsigned integer parameter to the program.
void | setNamedConstantFromTime (const String &name, Real factor)
| Sets a named parameter up to track a derivation of the current time.
void | setNamedSubroutine (const String &subroutineSlot, const String &subroutine)
| Set subroutine name by slot name.
void | setSubroutine (size_t index, const String &subroutine)
| Set subroutine name by slot index.
void | setTransposeMatrices (bool val)
| Sets whether or not we need to transpose the matrices passed in from the rest of OGRE.

## Static Public Member Functions
static const AutoConstantDefinition * | getAutoConstantDefinition (const size_t idx)
| gets the auto constant definition using an index into the auto constant definition array.
static const AutoConstantDefinition * | getAutoConstantDefinition (const String &name)
| gets the auto constant definition associated with name if found else returns NULL
static size_t | getNumAutoConstantDefinitions ()
| Returns the number of auto constant definitions.

## Detailed Description

Collects together the program parameters used for a GpuProgram.

Remarks
  Gpu program state includes constant parameters used by the program, and bindings to render system state which is propagated into the constants by the engine automatically if requested.

  GpuProgramParameters objects should be created through the GpuProgram and may be shared between multiple Pass instances. For this reason they are managed using a shared pointer, which will ensure they are automatically deleted when no Pass is using them anymore.

  High-level programs use named parameters (uniforms), low-level programs use indexed constants. This class supports both, but you can tell whether named constants are supported by calling hasNamedParameters(). There are references in the documentation below to 'logical' and 'physical' indexes; logical indexes are the indexes used by low-level programs and represent indexes into an array of float4's, some of which may be settable, some of which may be predefined constants in the program. We only store those constants which have actually been set, therefore our buffer could have gaps if we used the logical indexes in our own buffers. So instead we map these logical indexes to physical indexes in our buffer. When using high-level programs, logical indexes don't necessarily exist, although they might if the high-level program has a direct, exposed mapping from parameter names to logical indexes. In addition, high-level languages may or may not pack arrays of elements that are smaller than float4 (e.g. float2/vec2) contiguously. This kind of information is held in the ConstantDefinition structure which is only populated for high-level programs. You don't have to worry about any of this unless you intend to read parameters back from this structure rather than just setting them.

## Member Typedef Documentation

## ◆ AutoConstantIterator

typedef ConstVectorIterator<AutoConstantList> Ogre::GpuProgramParameters::AutoConstantIterator

## ◆ AutoConstantList

typedef vector<GpuProgramParameters_AutoConstantEntry>::type Ogre::GpuProgramParameters::AutoConstantList

## ◆ GpuSharedParamUsageList

typedef vector<GpuSharedParametersUsage>::type Ogre::GpuProgramParameters::GpuSharedParamUsageList

## ◆ SubroutineIterator

typedef unordered_map<size_t,String>::const_iterator Ogre::GpuProgramParameters::SubroutineIterator

## ◆ SubroutineMap

typedef unordered_map<size_t,String>::type Ogre::GpuProgramParameters::SubroutineMap

## Member Enumeration Documentation

## ◆ ACDataType

enum Ogre::GpuProgramParameters::ACDataType

Defines the type of the extra data item used by the auto constant.

Enumerator
ACDT_NONE | no data is required
ACDT_INT | the auto constant requires data of type int
ACDT_REAL | the auto constant requires data of type real (float or double)

## ◆ AutoConstantType

enum Ogre::GpuProgramParameters::AutoConstantType

Defines the types of automatically updated values that may be bound to GpuProgram parameters, or used to modify parameters on a per-object basis.

Enumerator
ACT_WORLD_MATRIX | The current world matrix.
ACT_INVERSE_WORLD_MATRIX | The current world matrix, inverted.
ACT_TRANSPOSE_WORLD_MATRIX | Provides transpose of world matrix. Equivalent to RenderMonkey's "WorldTranspose".
ACT_INVERSE_TRANSPOSE_WORLD_MATRIX | The current world matrix, inverted & transposed.
ACT_WORLD_MATRIX_ARRAY_3x4 | The current array of world matrices, as a 3x4 matrix, used for blending.
ACT_WORLD_MATRIX_ARRAY | The current array of world matrices, used for blending.
ACT_WORLD_DUALQUATERNION_ARRAY_2x4 | The current array of world matrices transformed to an array of dual quaternions, represented as a 2x4 matrix.
ACT_WORLD_SCALE_SHEAR_MATRIX_ARRAY_3x4 | The scale and shear components of the current array of world matrices.
ACT_VIEW_MATRIX | The current view matrix.
ACT_INVERSE_VIEW_MATRIX | The current view matrix, inverted.
ACT_TRANSPOSE_VIEW_MATRIX | Provides transpose of view matrix. Equivalent to RenderMonkey's "ViewTranspose".
ACT_INVERSE_TRANSPOSE_VIEW_MATRIX | Provides inverse transpose of view matrix. Equivalent to RenderMonkey's "ViewInverseTranspose".
ACT_PROJECTION_MATRIX | The current projection matrix.
ACT_INVERSE_PROJECTION_MATRIX | Provides inverse of projection matrix. Equivalent to RenderMonkey's "ProjectionInverse".
ACT_TRANSPOSE_PROJECTION_MATRIX | Provides transpose of projection matrix. Equivalent to RenderMonkey's "ProjectionTranspose".
ACT_INVERSE_TRANSPOSE_PROJECTION_MATRIX | Provides inverse transpose of projection matrix. Equivalent to RenderMonkey's "ProjectionInverseTranspose".
ACT_VIEWPROJ_MATRIX | The current view & projection matrices concatenated.
ACT_INVERSE_VIEWPROJ_MATRIX | Provides inverse of concatenated view and projection matrices. Equivalent to RenderMonkey's "ViewProjectionInverse".
ACT_TRANSPOSE_VIEWPROJ_MATRIX | Provides transpose of concatenated view and projection matrices. Equivalent to RenderMonkey's "ViewProjectionTranspose".
ACT_INVERSE_TRANSPOSE_VIEWPROJ_MATRIX | Provides inverse transpose of concatenated view and projection matrices. Equivalent to RenderMonkey's "ViewProjectionInverseTranspose".
ACT_WORLDVIEW_MATRIX | The current world & view matrices concatenated.
ACT_INVERSE_WORLDVIEW_MATRIX | The current world & view matrices concatenated, then inverted.
ACT_TRANSPOSE_WORLDVIEW_MATRIX | Provides transpose of concatenated world and view matrices. Equivalent to RenderMonkey's "WorldViewTranspose".
ACT_INVERSE_TRANSPOSE_WORLDVIEW_MATRIX | The current world & view matrices concatenated, then inverted & transposed.
ACT_WORLDVIEWPROJ_MATRIX | view matrices. The current world, view & projection matrices concatenated
ACT_INVERSE_WORLDVIEWPROJ_MATRIX | Provides inverse of concatenated world, view and projection matrices. Equivalent to RenderMonkey's "WorldViewProjectionInverse".
ACT_TRANSPOSE_WORLDVIEWPROJ_MATRIX | Provides transpose of concatenated world, view and projection matrices. Equivalent to RenderMonkey's "WorldViewProjectionTranspose".
ACT_INVERSE_TRANSPOSE_WORLDVIEWPROJ_MATRIX | Provides inverse transpose of concatenated world, view and projection matrices. Equivalent to RenderMonkey's "WorldViewProjectionInverseTranspose".
ACT_RENDER_TARGET_FLIPPING | render target related values -1 if requires texture flipping, +1 otherwise. It's useful when you bypassed projection matrix transform, still able use this value to adjust transformed y position.
ACT_VERTEX_WINDING | -1 if the winding has been inverted (e.g. for reflections), +1 otherwise.
ACT_FOG_COLOUR | Fog colour.
ACT_FOG_PARAMS | Fog params: density, linear start, linear end, 1/(end-start)
ACT_SURFACE_AMBIENT_COLOUR | Surface ambient colour, as set in Pass::setAmbient.
ACT_SURFACE_DIFFUSE_COLOUR | Surface diffuse colour, as set in Pass::setDiffuse.
ACT_SURFACE_SPECULAR_COLOUR | Surface specular colour, as set in Pass::setSpecular.
ACT_SURFACE_EMISSIVE_COLOUR | Surface emissive colour, as set in Pass::setSelfIllumination.
ACT_SURFACE_SHININESS | Surface shininess, as set in Pass::setShininess.
ACT_SURFACE_ALPHA_REJECTION_VALUE | Surface alpha rejection value, not as set in Pass::setAlphaRejectionValue, but a floating number between 0.0f and 1.0f instead (255.0f / Pass::getAlphaRejectionValue())
ACT_LIGHT_COUNT | The number of active light sources (better than gl_MaxLights)
ACT_AMBIENT_LIGHT_COLOUR | The ambient light colour set in the scene.
ACT_LIGHT_DIFFUSE_COLOUR | Light diffuse colour (index determined by setAutoConstant call)
ACT_LIGHT_SPECULAR_COLOUR | Light specular colour (index determined by setAutoConstant call)
ACT_LIGHT_ATTENUATION | Light attenuation parameters, Vector4(range, constant, linear, quadric)
ACT_SPOTLIGHT_PARAMS | Spotlight parameters, Vector4(innerFactor, outerFactor, falloff, isSpot) innerFactor and outerFactor are cos(angle/2) The isSpot parameter is 0.0f for non-spotlights, 1.0f for spotlights. Also for non-spotlights the inner and outer factors are 1 and nearly 1 respectively
ACT_LIGHT_POSITION | A light position in world space (index determined by setAutoConstant call)
ACT_LIGHT_POSITION_OBJECT_SPACE | A light position in object space (index determined by setAutoConstant call)
ACT_LIGHT_POSITION_VIEW_SPACE | A light position in view space (index determined by setAutoConstant call)
ACT_LIGHT_DIRECTION | A light direction in world space (index determined by setAutoConstant call)
ACT_LIGHT_DIRECTION_OBJECT_SPACE | A light direction in object space (index determined by setAutoConstant call)
ACT_LIGHT_DIRECTION_VIEW_SPACE | A light direction in view space (index determined by setAutoConstant call)
ACT_LIGHT_DISTANCE_OBJECT_SPACE | The distance of the light from the center of the object a useful approximation as an alternative to per-vertex distance calculations.
ACT_LIGHT_POWER_SCALE | Light power level, a single scalar as set in Light::setPowerScale (index determined by setAutoConstant call)
ACT_LIGHT_DIFFUSE_COLOUR_POWER_SCALED | Light diffuse colour pre-scaled by Light::setPowerScale (index determined by setAutoConstant call)
ACT_LIGHT_SPECULAR_COLOUR_POWER_SCALED | Light specular colour pre-scaled by Light::setPowerScale (index determined by setAutoConstant call)
ACT_LIGHT_DIFFUSE_COLOUR_ARRAY | Array of light diffuse colours (count set by extra param)
ACT_LIGHT_SPECULAR_COLOUR_ARRAY | Array of light specular colours (count set by extra param)
ACT_LIGHT_DIFFUSE_COLOUR_POWER_SCALED_ARRAY | Array of light diffuse colours scaled by light power (count set by extra param)
ACT_LIGHT_SPECULAR_COLOUR_POWER_SCALED_ARRAY | Array of light specular colours scaled by light power (count set by extra param)
ACT_LIGHT_ATTENUATION_ARRAY | Array of light attenuation parameters, Vector4(range, constant, linear, quadric) (count set by extra param)
ACT_LIGHT_POSITION_ARRAY | Array of light positions in world space (count set by extra param)
ACT_LIGHT_POSITION_OBJECT_SPACE_ARRAY | Array of light positions in object space (count set by extra param)
ACT_LIGHT_POSITION_VIEW_SPACE_ARRAY | Array of light positions in view space (count set by extra param)
ACT_LIGHT_DIRECTION_ARRAY | Array of light directions in world space (count set by extra param)
ACT_LIGHT_DIRECTION_OBJECT_SPACE_ARRAY | Array of light directions in object space (count set by extra param)
ACT_LIGHT_DIRECTION_VIEW_SPACE_ARRAY | Array of light directions in view space (count set by extra param)
ACT_LIGHT_DISTANCE_OBJECT_SPACE_ARRAY | Array of distances of the lights from the center of the object a useful approximation as an alternative to per-vertex distance calculations. (count set by extra param)
ACT_LIGHT_POWER_SCALE_ARRAY | Array of light power levels, a single scalar as set in Light::setPowerScale (count set by extra param)
ACT_SPOTLIGHT_PARAMS_ARRAY | Spotlight parameters array of Vector4(innerFactor, outerFactor, falloff, isSpot) innerFactor and outerFactor are cos(angle/2) The isSpot parameter is 0.0f for non-spotlights, 1.0f for spotlights. Also for non-spotlights the inner and outer factors are 1 and nearly 1 respectively. (count set by extra param)
ACT_DERIVED_AMBIENT_LIGHT_COLOUR | The derived ambient light colour, with 'r', 'g', 'b' components filled with product of surface ambient colour and ambient light colour, respectively, and 'a' component filled with surface ambient alpha component.
ACT_DERIVED_SCENE_COLOUR | The derived scene colour, with 'r', 'g' and 'b' components filled with sum of derived ambient light colour and surface emissive colour, respectively, and 'a' component filled with surface diffuse alpha component.
ACT_DERIVED_LIGHT_DIFFUSE_COLOUR | The derived light diffuse colour (index determined by setAutoConstant call), with 'r', 'g' and 'b' components filled with product of surface diffuse colour, light power scale and light diffuse colour, respectively, and 'a' component filled with surface diffuse alpha component.
ACT_DERIVED_LIGHT_SPECULAR_COLOUR | The derived light specular colour (index determined by setAutoConstant call), with 'r', 'g' and 'b' components filled with product of surface specular colour and light specular colour, respectively, and 'a' component filled with surface specular alpha component.
ACT_DERIVED_LIGHT_DIFFUSE_COLOUR_ARRAY | Array of derived light diffuse colours (count set by extra param)
ACT_DERIVED_LIGHT_SPECULAR_COLOUR_ARRAY | Array of derived light specular colours (count set by extra param)
ACT_LIGHT_CASTS_SHADOWS | Returns (int) 1 if the given light casts shadows, 0 otherwise (index set in extra param)
ACT_LIGHT_CASTS_SHADOWS_ARRAY | Returns (int) 1 if the given light casts shadows, 0 otherwise (index set in extra param)
ACT_SHADOW_EXTRUSION_DISTANCE | The distance a shadow volume should be extruded when using finite extrusion programs.
ACT_CAMERA_POSITION | The current camera's position in world space.
ACT_CAMERA_POSITION_OBJECT_SPACE | The current camera's position in object space.
ACT_TEXTURE_VIEWPROJ_MATRIX | The view/projection matrix of the assigned texture projection frustum.
ACT_TEXTURE_VIEWPROJ_MATRIX_ARRAY | Array of view/projection matrices of the first n texture projection frustums.
ACT_TEXTURE_WORLDVIEWPROJ_MATRIX | The view/projection matrix of the assigned texture projection frustum, combined with the current world matrix.
ACT_TEXTURE_WORLDVIEWPROJ_MATRIX_ARRAY | Array of world/view/projection matrices of the first n texture projection frustums.
ACT_SPOTLIGHT_VIEWPROJ_MATRIX | The view/projection matrix of a given spotlight.
ACT_SPOTLIGHT_VIEWPROJ_MATRIX_ARRAY | Array of view/projection matrix of a given spotlight.
ACT_SPOTLIGHT_WORLDVIEWPROJ_MATRIX | The view/projection matrix of a given spotlight projection frustum, combined with the current world matrix.
ACT_SPOTLIGHT_WORLDVIEWPROJ_MATRIX_ARRAY | An array of the view/projection matrix of a given spotlight projection frustum, combined with the current world matrix.
ACT_RS_DEPTH_RANGE | .x = 'min' / 'close' value according to current RS depth mode .y = 'max' / 'far' value according to current RS depth mode e.g. Reverse-Z: .xy = 1.0, 0.0 D3D11 & Metal, non-reverse-Z: .xy = 0.0, 1.0 GL, non-reverse-Z: .xy = -1.0, 1.0
ACT_CUSTOM | A custom parameter which will come from the renderable, using 'data' as the identifier.
ACT_TIME | provides current elapsed time
ACT_TIME_0_X | Single float value, which repeats itself based on given as parameter "cycle time". Equivalent to RenderMonkey's "Time0_X".
ACT_COSTIME_0_X | Cosine of "Time0_X". Equivalent to RenderMonkey's "CosTime0_X".
ACT_SINTIME_0_X | Sine of "Time0_X". Equivalent to RenderMonkey's "SinTime0_X".
ACT_TANTIME_0_X | Tangent of "Time0_X". Equivalent to RenderMonkey's "TanTime0_X".
ACT_TIME_0_X_PACKED | Vector of "Time0_X", "SinTime0_X", "CosTime0_X", "TanTime0_X". Equivalent to RenderMonkey's "Time0_X_Packed".
ACT_TIME_0_1 | Single float value, which represents scaled time value [0..1], which repeats itself based on given as parameter "cycle time". Equivalent to RenderMonkey's "Time0_1".
ACT_COSTIME_0_1 | Cosine of "Time0_1". Equivalent to RenderMonkey's "CosTime0_1".
ACT_SINTIME_0_1 | Sine of "Time0_1". Equivalent to RenderMonkey's "SinTime0_1".
ACT_TANTIME_0_1 | Tangent of "Time0_1". Equivalent to RenderMonkey's "TanTime0_1".
ACT_TIME_0_1_PACKED | Vector of "Time0_1", "SinTime0_1", "CosTime0_1", "TanTime0_1". Equivalent to RenderMonkey's "Time0_1_Packed".
ACT_TIME_0_2PI | Single float value, which represents scaled time value [0..2*Pi], which repeats itself based on given as parameter "cycle time". Equivalent to RenderMonkey's "Time0_2PI".
ACT_COSTIME_0_2PI | Cosine of "Time0_2PI". Equivalent to RenderMonkey's "CosTime0_2PI".
ACT_SINTIME_0_2PI | Sine of "Time0_2PI". Equivalent to RenderMonkey's "SinTime0_2PI".
ACT_TANTIME_0_2PI | Tangent of "Time0_2PI". Equivalent to RenderMonkey's "TanTime0_2PI".
ACT_TIME_0_2PI_PACKED | Vector of "Time0_2PI", "SinTime0_2PI", "CosTime0_2PI", "TanTime0_2PI". Equivalent to RenderMonkey's "Time0_2PI_Packed".
ACT_FRAME_TIME | provides the scaled frame time, returned as a floating point value.
ACT_FPS | provides the calculated frames per second, returned as a floating point value.
ACT_VIEWPORT_WIDTH | viewport-related values Current viewport width (in pixels) as floating point value. Equivalent to RenderMonkey's "ViewportWidth".
ACT_VIEWPORT_HEIGHT | Current viewport height (in pixels) as floating point value. Equivalent to RenderMonkey's "ViewportHeight".
ACT_INVERSE_VIEWPORT_WIDTH | This variable represents 1.0/ViewportWidth. Equivalent to RenderMonkey's "ViewportWidthInverse".
ACT_INVERSE_VIEWPORT_HEIGHT | This variable represents 1.0/ViewportHeight. Equivalent to RenderMonkey's "ViewportHeightInverse".
ACT_VIEWPORT_SIZE | Packed of "ViewportWidth", "ViewportHeight", "ViewportWidthInverse", "ViewportHeightInverse".
ACT_VIEW_DIRECTION | view parameters This variable provides the view direction vector (world space). Equivalent to RenderMonkey's "ViewDirection".
ACT_VIEW_SIDE_VECTOR | This variable provides the view side vector (world space). Equivalent to RenderMonkey's "ViewSideVector".
ACT_VIEW_UP_VECTOR | This variable provides the view up vector (world space). Equivalent to RenderMonkey's "ViewUpVector".
ACT_FOV | This variable provides the field of view as a floating point value. Equivalent to RenderMonkey's "FOV".
ACT_NEAR_CLIP_DISTANCE | This variable provides the near clip distance as a floating point value. Equivalent to RenderMonkey's "NearClipPlane".
ACT_FAR_CLIP_DISTANCE | This variable provides the far clip distance as a floating point value. Equivalent to RenderMonkey's "FarClipPlane".
ACT_PASS_NUMBER | provides the pass index number within the technique of the active materil.
ACT_PASS_ITERATION_NUMBER | provides the current iteration number of the pass. The iteration number is the number of times the current render operation has been drawn for the active pass.
ACT_ANIMATION_PARAMETRIC | Provides a parametric animation value [0..1], only available where the renderable specifically implements it.
ACT_TEXEL_OFFSETS | Provides the texel offsets required by this rendersystem to map texels to pixels. Packed as float4(absoluteHorizontalOffset, absoluteVerticalOffset, horizontalOffset / viewportWidth, verticalOffset / viewportHeight)
ACT_SCENE_DEPTH_RANGE | Provides information about the depth range of the scene as viewed from the current camera. Passed as float4(minDepth, maxDepth, depthRange, 1 / depthRange)
ACT_SHADOW_SCENE_DEPTH_RANGE | Provides information about the depth range of the scene as viewed from a given shadow camera. Requires an index parameter which maps to a light index relative to the current light list. Passed as float4(minDepth, maxDepth, depthRange, 1 / depthRange)
ACT_SHADOW_SCENE_DEPTH_RANGE_ARRAY | Provides an array of information about the depth range of the scene as viewed from a given shadow camera. Requires an index parameter which maps to a light index relative to the current light list. Passed as float4(minDepth, maxDepth, depthRange, 1 / depthRange)
ACT_SHADOW_COLOUR | Provides the fixed shadow colour as configured via SceneManager::setShadowColour; useful for integrated modulative shadows.
ACT_UAV_SIZE | Provides texture size of the texture unit (index determined by setAutoConstant call). Packed as float4(width, height, depth, 1)
ACT_INVERSE_UAV_SIZE | Provides inverse uav size of the uav unit (index determined by setAutoConstant call). Packed as float4(1 / width, 1 / height, 1 / depth, 1)
ACT_PACKED_UAV_SIZE | Provides packed uav size of the uav unit (index determined by setAutoConstant call). Packed as float4(width, height, 1 / width, 1 / height)
ACT_TEXTURE_SIZE | Provides texture size of the texture unit (index determined by setAutoConstant call). Packed as float4(width, height, depth, 1)
ACT_INVERSE_TEXTURE_SIZE | Provides inverse texture size of the texture unit (index determined by setAutoConstant call). Packed as float4(1 / width, 1 / height, 1 / depth, 1)
ACT_PACKED_TEXTURE_SIZE | Provides packed texture size of the texture unit (index determined by setAutoConstant call). Packed as float4(width, height, 1 / width, 1 / height)
ACT_TEXTURE_MATRIX | Provides the current transform matrix of the texture unit (index determined by setAutoConstant call), as it used to be seen by the now-removed fixed-function pipeline.
ACT_LOD_CAMERA_POSITION | Provides the position of the LOD camera in world space, allowing you to perform separate LOD calculations in shaders independent of the rendering camera. If there is no separate LOD camera then this is the real camera position. See Camera::setLodCamera.
ACT_LOD_CAMERA_POSITION_OBJECT_SPACE | Provides the position of the LOD camera in object space, allowing you to perform separate LOD calculations in shaders independent of the rendering camera. If there is no separate LOD camera then this is the real camera position. See Camera::setLodCamera.
ACT_LIGHT_CUSTOM | Binds custom per-light constants to the shaders.
ACT_PSSM_SPLITS | Array of PSSM split points (pixel depth must be lower) in projection space. Extra param indicates which shadow map it comes from.
ACT_PSSM_BLENDS | Array of PSSM blend points (pixel depth must be lower) in projection space. Extra param indicates which shadow map it comes from.
ACT_PSSM_FADE | PSSM fade point (pixel depth must be lower) in projection space. Extra param indicates which shadow map it comes from.
ACT_UNKNOWN |

## ◆ ElementType

enum Ogre::GpuProgramParameters::ElementType

Defines the base element type of the auto constant.

Enumerator
ET_INT |
ET_REAL |

## Constructor & Destructor Documentation

## ◆ GpuProgramParameters() [1/2]

Ogre::GpuProgramParameters::GpuProgramParameters | ( |  | ) |

Referenced by GpuProgramParameters(), copyConstantsFrom(), copyMatchingNamedConstantsFrom(), and operator=().

## ◆ ~GpuProgramParameters()

Ogre::GpuProgramParameters::~GpuProgramParameters | ( |  | ) |
| default

## ◆ GpuProgramParameters() [2/2]

Ogre::GpuProgramParameters::GpuProgramParameters | ( | const GpuProgramParameters & | oth | ) |

Copy constructor.

References GpuProgramParameters().

## Member Function Documentation

## ◆ _copySharedParams()

void Ogre::GpuProgramParameters::_copySharedParams | ( |  | ) |

Update the parameters by copying the data from the shared parameters.

Note
  This method may not actually be called if the RenderSystem supports using shared parameters directly in their own shared buffer; in which case the values should not be copied out of the shared area into the individual parameter set, but bound separately.

## ◆ _findNamedConstantDefinition()

const GpuConstantDefinition * Ogre::GpuProgramParameters::_findNamedConstantDefinition | ( | const String & | name,
|  | bool | throwExceptionIfMissing = false ) const

Find a constant definition for a named parameter.

Remarks
  This method returns null if the named parameter did not exist, unlike getConstantDefinition which is more strict; unless you set the last parameter to true.

Parameters

  name | The name to look up
  throwExceptionIfMissing | If set to true, failure to find an entry will throw an exception.

## ◆ _findRawAutoConstantEntryBool()

const GpuProgramParameters_AutoConstantEntry * Ogre::GpuProgramParameters::_findRawAutoConstantEntryBool | ( | size_t | physicalIndex | ) |

Finds an auto constant that's affecting a given physical position in the boolean buffer.

## ◆ _findRawAutoConstantEntryDouble()

const GpuProgramParameters_AutoConstantEntry * Ogre::GpuProgramParameters::_findRawAutoConstantEntryDouble | ( | size_t | physicalIndex | ) |

Finds an auto constant that's affecting a given physical position in the double-point buffer.

## ◆ _findRawAutoConstantEntryFloat()

const GpuProgramParameters_AutoConstantEntry * Ogre::GpuProgramParameters::_findRawAutoConstantEntryFloat | ( | size_t | physicalIndex | ) |

Finds an auto constant that's affecting a given physical position in the floating-point buffer.

## ◆ _findRawAutoConstantEntryInt()

const GpuProgramParameters_AutoConstantEntry * Ogre::GpuProgramParameters::_findRawAutoConstantEntryInt | ( | size_t | physicalIndex | ) |

Finds an auto constant that's affecting a given physical position in the integer buffer.

## ◆ _findRawAutoConstantEntryUnsignedInt()

const GpuProgramParameters_AutoConstantEntry * Ogre::GpuProgramParameters::_findRawAutoConstantEntryUnsignedInt | ( | size_t | physicalIndex | ) |

Finds an auto constant that's affecting a given physical position in the unsigned integer buffer.

## ◆ _getDoubleConstantPhysicalIndex()

size_t Ogre::GpuProgramParameters::_getDoubleConstantPhysicalIndex | ( | size_t | logicalIndex,
|  | size_t | requestedSize,
|  | uint16 | variability )

Gets the physical buffer index associated with a logical double constant index.

Note
  Only applicable to low-level programs.

Parameters

  logicalIndex | The logical parameter index
  requestedSize | The requested size - pass 0 to ignore missing entries and return std::numeric_limits<size_t>::max()

## ◆ _getFloatConstantPhysicalIndex()

size_t Ogre::GpuProgramParameters::_getFloatConstantPhysicalIndex | ( | size_t | logicalIndex,
|  | size_t | requestedSize,
|  | uint16 | variability )

Gets the physical buffer index associated with a logical float constant index.

Note
  Only applicable to low-level programs.

Parameters

  logicalIndex | The logical parameter index
  requestedSize | The requested size - pass 0 to ignore missing entries and return std::numeric_limits<size_t>::max()

## ◆ _getIntConstantPhysicalIndex()

size_t Ogre::GpuProgramParameters::_getIntConstantPhysicalIndex | ( | size_t | logicalIndex,
|  | size_t | requestedSize,
|  | uint16 | variability )

Gets the physical buffer index associated with a logical int constant index.

Note
  Only applicable to low-level programs.

Parameters

  logicalIndex | The logical parameter index
  requestedSize | The requested size - pass 0 to ignore missing entries and return std::numeric_limits<size_t>::max()

## ◆ _getUnsignedIntConstantPhysicalIndex()

size_t Ogre::GpuProgramParameters::_getUnsignedIntConstantPhysicalIndex | ( | size_t | logicalIndex,
|  | size_t | requestedSize,
|  | uint16 | variability )

Gets the physical buffer index associated with a logical unsigned int constant index.

Note
  Only applicable to low-level programs.

Parameters

  logicalIndex | The logical parameter index
  requestedSize | The requested size - pass 0 to ignore missing entries and return std::numeric_limits<size_t>::max()

## ◆ _readRawConstants() [1/2]

void Ogre::GpuProgramParameters::_readRawConstants | ( | size_t | physicalIndex,
|  | size_t | count,
|  | float * | dest )

Write a series of boolean values into the underlying integer constant buffer at the given physical index.

Parameters

  physicalIndex | The buffer position to start writing
  val | Pointer to a list of values to write
  count | The number of ints to write Read a series of floating point values from the underlying float constant buffer at the given physical index.
  physicalIndex | The buffer position to start reading
  count | The number of floats to read
  dest | Pointer to a buffer to receive the values

## ◆ _readRawConstants() [2/2]

void Ogre::GpuProgramParameters::_readRawConstants | ( | size_t | physicalIndex,
|  | size_t | count,
|  | int * | dest )

Read a series of integer values from the underlying integer constant buffer at the given physical index.

Parameters

  physicalIndex | The buffer position to start reading
  count | The number of ints to read
  dest | Pointer to a buffer to receive the values

## ◆ _setLogicalIndexes()

void Ogre::GpuProgramParameters::_setLogicalIndexes | ( | const GpuLogicalBufferStructPtr & | floatIndexMap,
|  | const GpuLogicalBufferStructPtr & | doubleIndexMap,
|  | const GpuLogicalBufferStructPtr & | intIndexMap,
|  | const GpuLogicalBufferStructPtr & | uintIndexMap,
|  | const GpuLogicalBufferStructPtr & | boolIndexMap )

Internal method for providing a link to a logical index->physical index map for parameters.

## ◆ _setNamedConstants()

void Ogre::GpuProgramParameters::_setNamedConstants | ( | const GpuNamedConstantsPtr & | constantmap | ) |

Internal method for providing a link to a name->definition map for parameters.

## ◆ _setRawAutoConstant()

void Ogre::GpuProgramParameters::_setRawAutoConstant | ( | size_t | physicalIndex,
|  | AutoConstantType | acType,
|  | size_t | extraInfo,
|  | uint16 | variability,
|  | size_t | elementSize = 4 )

As setAutoConstant, but sets up the auto constant directly against a physical buffer index.

## ◆ _setRawAutoConstantReal()

void Ogre::GpuProgramParameters::_setRawAutoConstantReal | ( | size_t | physicalIndex,
|  | AutoConstantType | acType,
|  | Real | rData,
|  | uint16 | variability,
|  | size_t | elementSize = 4 )

As setAutoConstantReal, but sets up the auto constant directly against a physical buffer index.

## ◆ _updateAutoParams()

void Ogre::GpuProgramParameters::_updateAutoParams | ( | const AutoParamDataSource * | source,
|  | uint16 | variabilityMask )

Update automatic parameters.

Parameters

  source | The source of the parameters
  variabilityMask | A mask of GpuParamVariability which identifies which autos will need updating

## ◆ _writeRawConstant() [1/11]

void Ogre::GpuProgramParameters::_writeRawConstant | ( | size_t | physicalIndex,
|  | bool | val )

Write a single boolean parameter to the program.

Note
  You can use these methods if you have already derived the physical constant buffer location, for a slight speed improvement over using the named / logical index versions.

Parameters

  physicalIndex | The physical buffer index at which to place the parameter
  val | The value to set

## ◆ _writeRawConstant() [2/11]

void Ogre::GpuProgramParameters::_writeRawConstant | ( | size_t | physicalIndex,
|  | const ColourValue & | colour,
|  | size_t | count = 4 )

Write a ColourValue parameter to the program.

Note
  You can use these methods if you have already derived the physical constant buffer location, for a slight speed improvement over using the named / logical index versions.

Parameters

  physicalIndex | The physical buffer index at which to place the parameter
  colour | The value to set
  count | The number of floats to write; if for example the uniform constant 'slot' is smaller than a Vector4

## ◆ _writeRawConstant() [3/11]

void Ogre::GpuProgramParameters::_writeRawConstant | ( | size_t | physicalIndex,
|  | const Matrix4 & | m,
|  | size_t | elementCount )

Write a Matrix4 parameter to the program.

Note
  You can use these methods if you have already derived the physical constant buffer location, for a slight speed improvement over using the named / logical index versions.

Parameters

  physicalIndex | The physical buffer index at which to place the parameter
  m | The value to set
  elementCount | actual element count used with shader

## ◆ _writeRawConstant() [4/11]

void Ogre::GpuProgramParameters::_writeRawConstant | ( | size_t | physicalIndex,
|  | const Matrix4 * | m,
|  | size_t | numEntries )

Write a list of Matrix4 parameters to the program.

Note
  You can use these methods if you have already derived the physical constant buffer location, for a slight speed improvement over using the named / logical index versions.

Parameters

  physicalIndex | The physical buffer index at which to place the parameter
  numEntries | Number of Matrix4 entries

## ◆ _writeRawConstant() [5/11]

void Ogre::GpuProgramParameters::_writeRawConstant | ( | size_t | physicalIndex,
|  | const Vector2 & | vec )

Write a 2-element floating-point parameter to the program via Vector2.

Note
  You can use these methods if you have already derived the physical constant buffer location, for a slight speed improvement over using the named / logical index versions.

Parameters

  physicalIndex | The physical buffer index at which to place the parameter
  vec | The value to set

## ◆ _writeRawConstant() [6/11]

void Ogre::GpuProgramParameters::_writeRawConstant | ( | size_t | physicalIndex,
|  | const Vector3 & | vec )

Write a 3-element floating-point parameter to the program via Vector3.

Note
  You can use these methods if you have already derived the physical constant buffer location, for a slight speed improvement over using the named / logical index versions.

Parameters

  physicalIndex | The physical buffer index at which to place the parameter
  vec | The value to set

## ◆ _writeRawConstant() [7/11]

void Ogre::GpuProgramParameters::_writeRawConstant | ( | size_t | physicalIndex,
|  | const Vector4 & | vec,
|  | size_t | count = 4 )

Write a 4-element floating-point parameter to the program directly to the underlying constants buffer.

Note
  You can use these methods if you have already derived the physical constant buffer location, for a slight speed improvement over using the named / logical index versions.

Parameters

  physicalIndex | The physical buffer index at which to place the parameter
  vec | The value to set
  count | The number of floats to write; if for example the uniform constant 'slot' is smaller than a Vector4

## ◆ _writeRawConstant() [8/11]

void Ogre::GpuProgramParameters::_writeRawConstant | ( | size_t | physicalIndex,
|  | int | val )

Write a single integer parameter to the program.

Note
  You can use these methods if you have already derived the physical constant buffer location, for a slight speed improvement over using the named / logical index versions.

Parameters

  physicalIndex | The physical buffer index at which to place the parameter
  val | The value to set

## ◆ _writeRawConstant() [9/11]

void Ogre::GpuProgramParameters::_writeRawConstant | ( | size_t | physicalIndex,
|  | Real | val )

Write a single floating-point parameter to the program.

Note
  You can use these methods if you have already derived the physical constant buffer location, for a slight speed improvement over using the named / logical index versions.

Parameters

  physicalIndex | The physical buffer index at which to place the parameter
  val | The value to set

## ◆ _writeRawConstant() [10/11]

void Ogre::GpuProgramParameters::_writeRawConstant | ( | size_t | physicalIndex,
|  | Real | val,
|  | size_t | count )

Write a variable number of floating-point parameters to the program.

Note
  You can use these methods if you have already derived the physical constant buffer location, for a slight speed improvement over using the named / logical index versions.

Parameters

  physicalIndex | The physical buffer index at which to place the parameter
  val | The value to set

## ◆ _writeRawConstant() [11/11]

void Ogre::GpuProgramParameters::_writeRawConstant | ( | size_t | physicalIndex,
|  | uint | val )

Write a single unsigned integer parameter to the program.

Note
  You can use these methods if you have already derived the physical constant buffer location, for a slight speed improvement over using the named / logical index versions.

Parameters

  physicalIndex | The physical buffer index at which to place the parameter
  val | The value to set

## ◆ _writeRawConstants() [1/4]

void Ogre::GpuProgramParameters::_writeRawConstants | ( | size_t | physicalIndex,
|  | const double * | val,
|  | size_t | count )

Write a series of floating point values into the underlying float constant buffer at the given physical index.

Parameters

  physicalIndex | The buffer position to start writing
  val | Pointer to a list of values to write
  count | The number of floats to write

## ◆ _writeRawConstants() [2/4]

void Ogre::GpuProgramParameters::_writeRawConstants | ( | size_t | physicalIndex,
|  | const float * | val,
|  | size_t | count )

Write a series of floating point values into the underlying float constant buffer at the given physical index.

Parameters

  physicalIndex | The buffer position to start writing
  val | Pointer to a list of values to write
  count | The number of floats to write

## ◆ _writeRawConstants() [3/4]

void Ogre::GpuProgramParameters::_writeRawConstants | ( | size_t | physicalIndex,
|  | const int * | val,
|  | size_t | count )

Write a series of integer values into the underlying integer constant buffer at the given physical index.

Parameters

  physicalIndex | The buffer position to start writing
  val | Pointer to a list of values to write
  count | The number of ints to write

## ◆ _writeRawConstants() [4/4]

void Ogre::GpuProgramParameters::_writeRawConstants | ( | size_t | physicalIndex,
|  | const uint * | val,
|  | size_t | count )

Write a series of unsigned integer values into the underlying integer constant buffer at the given physical index.

Parameters

  physicalIndex | The buffer position to start writing
  val | Pointer to a list of values to write
  count | The number of ints to write

## ◆ addSharedParameters() [1/2]

void Ogre::GpuProgramParameters::addSharedParameters | ( | const String & | sharedParamsName | ) |

Use a set of shared parameters in this parameters object.

Remarks
  Allows you to use a set of shared parameters to automatically update this parameter set.

Parameters

  sharedParamsName | The name of a shared parameter set as defined in GpuProgramManager

## ◆ addSharedParameters() [2/2]

void Ogre::GpuProgramParameters::addSharedParameters | ( | GpuSharedParametersPtr | sharedParams | ) |

Use a set of shared parameters in this parameters object.

Remarks
  Allows you to use a set of shared parameters to automatically update this parameter set.

## ◆ calculateSize()

size_t Ogre::GpuProgramParameters::calculateSize | ( |  | ) | const

## ◆ clearAutoConstant()

void Ogre::GpuProgramParameters::clearAutoConstant | ( | size_t | index | ) |

Unbind an auto constant so that the constant is manually controlled again.

## ◆ clearAutoConstants()

void Ogre::GpuProgramParameters::clearAutoConstants | ( |  | ) |

Clears all the existing automatic constants.

## ◆ clearNamedAutoConstant()

void Ogre::GpuProgramParameters::clearNamedAutoConstant | ( | const String & | name | ) |

Unbind an auto constant so that the constant is manually controlled again.

## ◆ copyConstantsFrom()

void Ogre::GpuProgramParameters::copyConstantsFrom | ( | const GpuProgramParameters & | source | ) |

Copies the values of all constants (including auto constants) from another GpuProgramParameters object.

Note
  This copes the internal storage of the paarameters object and therefore can only be used for parameters objects created from the same GpuProgram. To merge parameters that match from different programs, use copyMatchingNamedConstantsFrom.

References GpuProgramParameters().

## ◆ copyMatchingNamedConstantsFrom()

void Ogre::GpuProgramParameters::copyMatchingNamedConstantsFrom | ( | const GpuProgramParameters & | source | ) |

Copies the values of all matching named constants (including auto constants) from another GpuProgramParameters object.

Remarks
  This method iterates over the named constants in another parameters object and copies across the values where they match. This method is safe to use when the 2 parameters objects came from different programs, but only works for named parameters.

References GpuProgramParameters().

## ◆ findAutoConstantEntry()

const GpuProgramParameters_AutoConstantEntry * Ogre::GpuProgramParameters::findAutoConstantEntry | ( | const String & | paramName | ) |

Finds an auto constant that's affecting a given logical parameter index for boolean values.

Note
  Only applicable for low-level programs. Finds an auto constant that's affecting a given named parameter index.
  Only applicable to high-level programs.

## ◆ findDoubleAutoConstantEntry()

const GpuProgramParameters_AutoConstantEntry * Ogre::GpuProgramParameters::findDoubleAutoConstantEntry | ( | size_t | logicalIndex | ) |

Finds an auto constant that's affecting a given logical parameter index for double-point values.

Note
  Only applicable for low-level programs.

## ◆ findFloatAutoConstantEntry()

const GpuProgramParameters_AutoConstantEntry * Ogre::GpuProgramParameters::findFloatAutoConstantEntry | ( | size_t | logicalIndex | ) |

Finds an auto constant that's affecting a given logical parameter index for floating-point values.

Note
  Only applicable for low-level programs.

## ◆ findIntAutoConstantEntry()

const GpuProgramParameters_AutoConstantEntry * Ogre::GpuProgramParameters::findIntAutoConstantEntry | ( | size_t | logicalIndex | ) |

Finds an auto constant that's affecting a given logical parameter index for integer values.

Note
  Only applicable for low-level programs.

## ◆ findUnsignedIntAutoConstantEntry()

const GpuProgramParameters_AutoConstantEntry * Ogre::GpuProgramParameters::findUnsignedIntAutoConstantEntry | ( | size_t | logicalIndex | ) |

Finds an auto constant that's affecting a given logical parameter index for unsigned integer values.

Note
  Only applicable for low-level programs.

## ◆ getAutoConstantDefinition() [1/2]

static const AutoConstantDefinition * Ogre::GpuProgramParameters::getAutoConstantDefinition | ( | const size_t | idx | ) |
| static

gets the auto constant definition using an index into the auto constant definition array.

If the index is out of bounds then NULL is returned;

Parameters

  idx | The auto constant index

## ◆ getAutoConstantDefinition() [2/2]

static const AutoConstantDefinition * Ogre::GpuProgramParameters::getAutoConstantDefinition | ( | const String & | name | ) |
| static

gets the auto constant definition associated with name if found else returns NULL

Parameters

  name | The name of the auto constant

## ◆ getAutoConstantEntry()

GpuProgramParameters_AutoConstantEntry * Ogre::GpuProgramParameters::getAutoConstantEntry | ( | const size_t | index | ) |

Gets a specific Auto Constant entry if index is in valid range otherwise returns a NULL.

Parameters

  index | which entry is to be retrieved

## ◆ getAutoConstantIterator()

AutoConstantIterator Ogre::GpuProgramParameters::getAutoConstantIterator | ( |  | ) | const

Gets an iterator over the automatic constant bindings currently in place.

References getAutoConstantCount().

## ◆ getAutoConstantList()

const AutoConstantList & Ogre::GpuProgramParameters::getAutoConstantList | ( |  | ) | const
| inline

Get a reference to the list of auto constant bindings.

## ◆ getBoolLogicalBufferStruct()

const GpuLogicalBufferStructPtr & Ogre::GpuProgramParameters::getBoolLogicalBufferStruct | ( |  | ) | const
| inline

Get the current list of mappings from low-level logical param indexes to physical buffer locations in the integer buffer.

Note
  Only applicable to low-level programs.

## ◆ getBoolLogicalIndexForPhysicalIndex()

size_t Ogre::GpuProgramParameters::getBoolLogicalIndexForPhysicalIndex | ( | size_t | physicalIndex | ) |

Retrieves the logical index relating to a physical index in the bool buffer, for programs which support that (low-level programs and high-level programs which use logical parameter indexes).

Returns
  std::numeric_limits<size_t>::max() if not found

## ◆ getConstantDefinition()

const GpuConstantDefinition & Ogre::GpuProgramParameters::getConstantDefinition | ( | const String & | name | ) | const

Get a specific GpuConstantDefinition for a named parameter.

Note
  Only available if this parameters object has named parameters.

## ◆ getConstantDefinitionIterator()

GpuConstantDefinitionIterator Ogre::GpuProgramParameters::getConstantDefinitionIterator | ( |  | ) | const

Gets an iterator over the named GpuConstantDefinition instances as defined by the program for which these parameters exist.

Note
  Only available if this parameters object has named parameters.

## ◆ getConstantDefinitions()

const GpuNamedConstants & Ogre::GpuProgramParameters::getConstantDefinitions | ( |  | ) | const

Get the full list of GpuConstantDefinition instances.

Note
  Only available if this parameters object has named parameters.

## ◆ getDoubleConstantList()

const DoubleConstantList & Ogre::GpuProgramParameters::getDoubleConstantList | ( |  | ) | const
| inline

Get a reference to the list of double constants.

## ◆ getDoubleLogicalBufferStruct()

const GpuLogicalBufferStructPtr & Ogre::GpuProgramParameters::getDoubleLogicalBufferStruct | ( |  | ) | const
| inline

Get the current list of mappings from low-level logical param indexes to physical buffer locations in the double buffer.

Note
  Only applicable to low-level programs.

## ◆ getDoubleLogicalIndexForPhysicalIndex()

size_t Ogre::GpuProgramParameters::getDoubleLogicalIndexForPhysicalIndex | ( | size_t | physicalIndex | ) |

Retrieves the logical index relating to a physical index in the double buffer, for programs which support that (low-level programs and high-level programs which use logical parameter indexes).

Returns
  std::numeric_limits<size_t>::max() if not found

## ◆ getDoublePointer() [1/2]

double * Ogre::GpuProgramParameters::getDoublePointer | ( | size_t | pos | ) |
| inline

Get a pointer to the 'nth' item in the double buffer.

## ◆ getDoublePointer() [2/2]

const double * Ogre::GpuProgramParameters::getDoublePointer | ( | size_t | pos | ) | const
| inline

Get a pointer to the 'nth' item in the double buffer.

## ◆ getFloatConstantList()

const FloatConstantList & Ogre::GpuProgramParameters::getFloatConstantList | ( |  | ) | const
| inline

Get a reference to the list of float constants.

## ◆ getFloatLogicalBufferStruct()

const GpuLogicalBufferStructPtr & Ogre::GpuProgramParameters::getFloatLogicalBufferStruct | ( |  | ) | const
| inline

Get the current list of mappings from low-level logical param indexes to physical buffer locations in the float buffer.

Note
  Only applicable to low-level programs.

## ◆ getFloatLogicalIndexForPhysicalIndex()

size_t Ogre::GpuProgramParameters::getFloatLogicalIndexForPhysicalIndex | ( | size_t | physicalIndex | ) |

Retrieves the logical index relating to a physical index in the float buffer, for programs which support that (low-level programs and high-level programs which use logical parameter indexes).

Returns
  std::numeric_limits<size_t>::max() if not found

## ◆ getFloatPointer() [1/2]

float * Ogre::GpuProgramParameters::getFloatPointer | ( | size_t | pos | ) |
| inline

Get a pointer to the 'nth' item in the float buffer.

## ◆ getFloatPointer() [2/2]

const float * Ogre::GpuProgramParameters::getFloatPointer | ( | size_t | pos | ) | const
| inline

Get a pointer to the 'nth' item in the float buffer.

## ◆ getIntConstantList()

const IntConstantList & Ogre::GpuProgramParameters::getIntConstantList | ( |  | ) | const
| inline

Get a reference to the list of int constants.

## ◆ getIntLogicalBufferStruct()

const GpuLogicalBufferStructPtr & Ogre::GpuProgramParameters::getIntLogicalBufferStruct | ( |  | ) | const
| inline

Get the current list of mappings from low-level logical param indexes to physical buffer locations in the integer buffer.

Note
  Only applicable to low-level programs.

## ◆ getIntLogicalIndexForPhysicalIndex()

size_t Ogre::GpuProgramParameters::getIntLogicalIndexForPhysicalIndex | ( | size_t | physicalIndex | ) |

Retrieves the logical index relating to a physical index in the int buffer, for programs which support that (low-level programs and high-level programs which use logical parameter indexes).

Returns
  std::numeric_limits<size_t>::max() if not found

## ◆ getIntPointer() [1/2]

int * Ogre::GpuProgramParameters::getIntPointer | ( | size_t | pos | ) |
| inline

Get a pointer to the 'nth' item in the int buffer.

## ◆ getIntPointer() [2/2]

const int * Ogre::GpuProgramParameters::getIntPointer | ( | size_t | pos | ) | const
| inline

Get a pointer to the 'nth' item in the int buffer.

## ◆ getNumAutoConstantDefinitions()

static size_t Ogre::GpuProgramParameters::getNumAutoConstantDefinitions | ( |  | ) |
| static

Returns the number of auto constant definitions.

## ◆ getPassIterationNumberIndex()

size_t Ogre::GpuProgramParameters::getPassIterationNumberIndex | ( |  | ) | const
| inline

Get the physical buffer index of the pass iteration number constant.

## ◆ getSharedParameters()

const GpuSharedParamUsageList & Ogre::GpuProgramParameters::getSharedParameters | ( |  | ) | const

Get the list of shared parameter sets.

## ◆ getSubroutineMap()

const SubroutineMap & Ogre::GpuProgramParameters::getSubroutineMap | ( |  | ) | const
| inline

Get map with.

## ◆ getTransposeMatrices()

bool Ogre::GpuProgramParameters::getTransposeMatrices | ( |  | ) | const
| inline

Gets whether or not matrices are to be transposed when set.

## ◆ getUnsignedIntConstantList()

const UnsignedIntConstantList & Ogre::GpuProgramParameters::getUnsignedIntConstantList | ( |  | ) | const
| inline

Get a reference to the list of uint constants.

## ◆ getUnsignedIntLogicalBufferStruct()

const GpuLogicalBufferStructPtr & Ogre::GpuProgramParameters::getUnsignedIntLogicalBufferStruct | ( |  | ) | const
| inline

Get the current list of mappings from low-level logical param indexes to physical buffer locations in the integer buffer.

Note
  Only applicable to low-level programs.

## ◆ getUnsignedIntLogicalIndexForPhysicalIndex()

size_t Ogre::GpuProgramParameters::getUnsignedIntLogicalIndexForPhysicalIndex | ( | size_t | physicalIndex | ) |

Retrieves the logical index relating to a physical index in the uint buffer, for programs which support that (low-level programs and high-level programs which use logical parameter indexes).

Returns
  std::numeric_limits<size_t>::max() if not found

## ◆ getUnsignedIntPointer() [1/2]

uint * Ogre::GpuProgramParameters::getUnsignedIntPointer | ( | size_t | pos | ) |
| inline

Get a pointer to the 'nth' item in the uint buffer.

## ◆ getUnsignedIntPointer() [2/2]

const uint * Ogre::GpuProgramParameters::getUnsignedIntPointer | ( | size_t | pos | ) | const
| inline

Get a pointer to the 'nth' item in the uint buffer.

## ◆ hasAutoConstants()

bool Ogre::GpuProgramParameters::hasAutoConstants | ( |  | ) | const
| inline

Returns true if this instance has any automatic constants.

## ◆ hasLogicalIndexedParameters()

bool Ogre::GpuProgramParameters::hasLogicalIndexedParameters | ( |  | ) | const
| inline

Does this parameter set include logically indexed parameters?

Note
  Not mutually exclusive with hasNamedParameters since some high-level programs still use logical indexes to set the parameters on the rendersystem.

## ◆ hasNamedParameters()

bool Ogre::GpuProgramParameters::hasNamedParameters | ( |  | ) | const
| inline

Does this parameter set include named parameters?

## ◆ hasPassIterationNumber()

bool Ogre::GpuProgramParameters::hasPassIterationNumber | ( |  | ) | const
| inline

Does this parameters object have a pass iteration number constant?

## ◆ incPassIterationNumber()

void Ogre::GpuProgramParameters::incPassIterationNumber | ( |  | ) |

increments the multipass number entry by 1 if it exists

## ◆ isUsingSharedParameters()

bool Ogre::GpuProgramParameters::isUsingSharedParameters | ( | const String & | sharedParamsName | ) | const

Returns whether this parameter set is using the named shared parameter set.

## ◆ operator=()

GpuProgramParameters & Ogre::GpuProgramParameters::operator= | ( | const GpuProgramParameters & | oth | ) |

Operator = overload.

References GpuProgramParameters().

## ◆ removeAllSharedParameters()

void Ogre::GpuProgramParameters::removeAllSharedParameters | ( |  | ) |

Stop using all shared parameter sets.

## ◆ removeSharedParameters()

void Ogre::GpuProgramParameters::removeSharedParameters | ( | const String & | sharedParamsName | ) |

Stop using the named shared parameter set.

## ◆ setAutoConstant() [1/2]

void Ogre::GpuProgramParameters::setAutoConstant | ( | size_t | index,
|  | AutoConstantType | acType,
|  | size_t | extraInfo = 0 )

Sets up a constant which will automatically be updated by the system.

Remarks
  Vertex and fragment programs often need parameters which are to do with the current render state, or particular values which may very well change over time, and often between objects which are being rendered. This feature allows you to set up a certain number of predefined parameter mappings that are kept up to date for you.

Parameters

  index | The location in the constant list to place this updated constant every time it is changed. Note that because of the nature of the types, we know how big the parameter details will be so you don't need to set that like you do for manual constants.
  acType | The type of automatic constant to set
  extraInfo | If the constant type needs more information (like a light index) put it here.

## ◆ setAutoConstant() [2/2]

void Ogre::GpuProgramParameters::setAutoConstant | ( | size_t | index,
|  | AutoConstantType | acType,
|  | uint16 | extraInfo1,
|  | uint16 | extraInfo2 )

Sets up a constant which will automatically be updated by the system.

Remarks
  Vertex and fragment programs often need parameters which are to do with the current render state, or particular values which may very well change over time, and often between objects which are being rendered. This feature allows you to set up a certain number of predefined parameter mappings that are kept up to date for you.

Parameters

  index | The location in the constant list to place this updated constant every time it is changed. Note that because of the nature of the types, we know how big the parameter details will be so you don't need to set that like you do for manual constants.
  acType | The type of automatic constant to set
  extraInfo1 | The first extra parameter required by the auto constant type
  extraInfo2 | The first extra parameter required by the auto constant type

## ◆ setAutoConstantReal()

void Ogre::GpuProgramParameters::setAutoConstantReal | ( | size_t | index,
|  | AutoConstantType | acType,
|  | Real | rData )

## ◆ setConstant() [1/12]

void Ogre::GpuProgramParameters::setConstant | ( | size_t | index,
|  | const bool * | val,
|  | size_t | count )

Sets a multiple value constant boolean parameter to the program.

Remarks
  Different types of GPU programs support different types of constant parameters. For example, it's relatively common to find that vertex programs only support floating point constants, and that fragment programs only support integer (fixed point) parameters. This can vary depending on the program version supported by the graphics card being used. You should consult the documentation for the type of low level program you are using, or alternatively use the methods provided on RenderSystemCapabilities to determine the options.

Parameters

  index | The logical constant index at which to place the parameter (each constant is a 4D integer)
  val | Pointer to the values to write, must contain 4*count ints
  count | The number of groups of 4 ints to write

## ◆ setConstant() [2/12]

void Ogre::GpuProgramParameters::setConstant | ( | size_t | index,
|  | const ColourValue & | colour )

Sets a ColourValue parameter to the program.

Parameters

  index | The logical constant index at which to place the parameter (each constant is a 4D float)
  colour | The value to set

## ◆ setConstant() [3/12]

void Ogre::GpuProgramParameters::setConstant | ( | size_t | index,
|  | const double * | val,
|  | size_t | count )

Sets a multiple value constant floating-point parameter to the program.

Parameters

  index | The logical constant index at which to start placing parameters (each constant is a 4D float)
  val | Pointer to the values to write, must contain 4*count floats
  count | The number of groups of 4 floats to write

## ◆ setConstant() [4/12]

void Ogre::GpuProgramParameters::setConstant | ( | size_t | index,
|  | const float * | val,
|  | size_t | count )

Sets a multiple value constant floating-point parameter to the program.

Parameters

  index | The logical constant index at which to start placing parameters (each constant is a 4D float)
  val | Pointer to the values to write, must contain 4*count floats
  count | The number of groups of 4 floats to write

## ◆ setConstant() [5/12]

void Ogre::GpuProgramParameters::setConstant | ( | size_t | index,
|  | const int * | val,
|  | size_t | count )

Sets a multiple value constant integer parameter to the program.

Remarks
  Different types of GPU programs support different types of constant parameters. For example, it's relatively common to find that vertex programs only support floating point constants, and that fragment programs only support integer (fixed point) parameters. This can vary depending on the program version supported by the graphics card being used. You should consult the documentation for the type of low level program you are using, or alternatively use the methods provided on RenderSystemCapabilities to determine the options.

Parameters

  index | The logical constant index at which to place the parameter (each constant is a 4D integer)
  val | Pointer to the values to write, must contain 4*count ints
  count | The number of groups of 4 ints to write

## ◆ setConstant() [6/12]

void Ogre::GpuProgramParameters::setConstant | ( | size_t | index,
|  | const Matrix4 & | m )

Sets a Matrix4 parameter to the program.

Parameters

  index | The logical constant index at which to place the parameter (each constant is a 4D float). NB since a Matrix4 is 16 floats long, this parameter will take up 4 indexes.
  m | The value to set

## ◆ setConstant() [7/12]

void Ogre::GpuProgramParameters::setConstant | ( | size_t | index,
|  | const Matrix4 * | m,
|  | size_t | numEntries )

Sets a list of Matrix4 parameters to the program.

Parameters

  index | The logical constant index at which to start placing the parameter (each constant is a 4D float). NB since a Matrix4 is 16 floats long, so each entry will take up 4 indexes.
  m | Pointer to an array of matrices to set
  numEntries | Number of Matrix4 entries

## ◆ setConstant() [8/12]

void Ogre::GpuProgramParameters::setConstant | ( | size_t | index,
|  | const uint * | val,
|  | size_t | count )

Sets a multiple value constant unsigned integer parameter to the program.

Remarks
  Different types of GPU programs support different types of constant parameters. For example, it's relatively common to find that vertex programs only support floating point constants, and that fragment programs only support integer (fixed point) parameters. This can vary depending on the program version supported by the graphics card being used. You should consult the documentation for the type of low level program you are using, or alternatively use the methods provided on RenderSystemCapabilities to determine the options.

Parameters

  index | The logical constant index at which to place the parameter (each constant is a 4D integer)
  val | Pointer to the values to write, must contain 4*count ints
  count | The number of groups of 4 ints to write

## ◆ setConstant() [9/12]

void Ogre::GpuProgramParameters::setConstant | ( | size_t | index,
|  | const Vector2 & | vec )

Sets a 4-element floating-point parameter to the program via Vector2.

Parameters

  index | The logical constant index at which to place the parameter (each constant is a 4D float). Note that since you're passing a Vector2, the last 2 elements of the 4-element value will be set to 1 (a homogeneous vector)
  vec | The value to set

## ◆ setConstant() [10/12]

void Ogre::GpuProgramParameters::setConstant | ( | size_t | index,
|  | const Vector3 & | vec )

Sets a 4-element floating-point parameter to the program via Vector3.

Parameters

  index | The logical constant index at which to place the parameter (each constant is a 4D float). Note that since you're passing a Vector3, the last element of the 4-element value will be set to 1 (a homogeneous vector)
  vec | The value to set

## ◆ setConstant() [11/12]

void Ogre::GpuProgramParameters::setConstant | ( | size_t | index,
|  | const Vector4 & | vec )

Sets a 4-element floating-point parameter to the program.

Parameters

  index | The logical constant index at which to place the parameter (each constant is a 4D float)
  vec | The value to set

## ◆ setConstant() [12/12]

void Ogre::GpuProgramParameters::setConstant | ( | size_t | index,
|  | Real | val )

Sets a single floating-point parameter to the program.

Note
  This is actually equivalent to calling setConstant(index Vector4(val, 0, 0, 0)) since all constants are 4D.

Parameters

  index | The logical constant index at which to place the parameter (each constant is a 4D float)
  val | The value to set

## ◆ setConstantFromTime()

void Ogre::GpuProgramParameters::setConstantFromTime | ( | size_t | index,
|  | Real | factor )

Sets a named parameter up to track a derivation of the current time.

Parameters

  index | The index of the parameter
  factor | The amount by which to scale the time value

## ◆ setIgnoreMissingParams()

void Ogre::GpuProgramParameters::setIgnoreMissingParams | ( | bool | state | ) |
| inline

Tells the program whether to ignore missing parameters or not.

## ◆ setNamedAutoConstant() [1/2]

void Ogre::GpuProgramParameters::setNamedAutoConstant | ( | const String & | name,
|  | AutoConstantType | acType,
|  | size_t | extraInfo = 0 )

Sets a multiple value constant boolean parameter to the program.

  Some systems only allow constants to be set on certain boundaries, e.g. in sets of 4 values for example. The 'multiple' parameter allows you to control that although you should only change it if you know your chosen language supports that (at the time of writing, only GLSL allows constants which are not a multiple of 4).

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  val | Pointer to the values to write
  count | The number of 'multiples' of floats to write
  multiple | The number of raw entries in each element to write, the default is 4 so count = 1 would write 4 floats. Sets up a constant which will automatically be updated by the system.

Remarks
  Vertex and fragment programs often need parameters which are to do with the current render state, or particular values which may very well change over time, and often between objects which are being rendered. This feature allows you to set up a certain number of predefined parameter mappings that are kept up to date for you.

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  acType | The type of automatic constant to set
  extraInfo | If the constant type needs more information (like a light index) put it here.

## ◆ setNamedAutoConstant() [2/2]

void Ogre::GpuProgramParameters::setNamedAutoConstant | ( | const String & | name,
|  | AutoConstantType | acType,
|  | uint16 | extraInfo1,
|  | uint16 | extraInfo2 )

Sets up a constant which will automatically be updated by the system.

Remarks
  Vertex and fragment programs often need parameters which are to do with the current render state, or particular values which may very well change over time, and often between objects which are being rendered. This feature allows you to set up a certain number of predefined parameter mappings that are kept up to date for you.

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  acType | The type of automatic constant to set
  extraInfo1 | The first extra info required by this auto constant type
  extraInfo2 | The first extra info required by this auto constant type

## ◆ setNamedAutoConstantReal()

void Ogre::GpuProgramParameters::setNamedAutoConstantReal | ( | const String & | name,
|  | AutoConstantType | acType,
|  | Real | rData )

## ◆ setNamedConstant() [1/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | const ColourValue & | colour )

Sets a ColourValue parameter to the program.

Parameters

  name | The name of the parameter
  colour | The value to set

## ◆ setNamedConstant() [2/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | const double * | val,
|  | size_t | count,
|  | size_t | multiple = 4 )

Sets a multiple value constant floating-point parameter to the program.

  Some systems only allow constants to be set on certain boundaries, e.g. in sets of 4 values for example. The 'multiple' parameter allows you to control that although you should only change it if you know your chosen language supports that (at the time of writing, only GLSL allows constants which are not a multiple of 4).

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  val | Pointer to the values to write
  count | The number of 'multiples' of floats to write
  multiple | The number of raw entries in each element to write, the default is 4 so count = 1 would write 4 floats.

## ◆ setNamedConstant() [3/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | const float * | val,
|  | size_t | count,
|  | size_t | multiple = 4 )

Sets a multiple value constant floating-point parameter to the program.

  Some systems only allow constants to be set on certain boundaries, e.g. in sets of 4 values for example. The 'multiple' parameter allows you to control that although you should only change it if you know your chosen language supports that (at the time of writing, only GLSL allows constants which are not a multiple of 4).

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  val | Pointer to the values to write
  count | The number of 'multiples' of floats to write
  multiple | The number of raw entries in each element to write, the default is 4 so count = 1 would write 4 floats.

## ◆ setNamedConstant() [4/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | const int * | val,
|  | size_t | count,
|  | size_t | multiple = 4 )

Sets a multiple value constant integer parameter to the program.

  Some systems only allow constants to be set on certain boundaries, e.g. in sets of 4 values for example. The 'multiple' parameter allows you to control that although you should only change it if you know your chosen language supports that (at the time of writing, only GLSL allows constants which are not a multiple of 4).

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  val | Pointer to the values to write
  count | The number of 'multiples' of floats to write
  multiple | The number of raw entries in each element to write, the default is 4 so count = 1 would write 4 floats.

## ◆ setNamedConstant() [5/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | const Matrix3 & | m )

## ◆ setNamedConstant() [6/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | const Matrix4 & | m )

Sets a Matrix4 parameter to the program.

Parameters

  name | The name of the parameter
  m | The value to set

## ◆ setNamedConstant() [7/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | const Matrix4 * | m,
|  | size_t | numEntries )

Sets a list of Matrix4 parameters to the program.

Parameters

  name | The name of the parameter; this must be the first index of an array, for examples 'matrices[0]' NB since a Matrix4 is 16 floats long, so each entry will take up 4 indexes.
  m | Pointer to an array of matrices to set
  numEntries | Number of Matrix4 entries

## ◆ setNamedConstant() [8/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | const uint * | val,
|  | size_t | count,
|  | size_t | multiple = 4 )

Sets a multiple value constant unsigned integer parameter to the program.

  Some systems only allow constants to be set on certain boundaries, e.g. in sets of 4 values for example. The 'multiple' parameter allows you to control that although you should only change it if you know your chosen language supports that (at the time of writing, only GLSL allows constants which are not a multiple of 4).

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  val | Pointer to the values to write
  count | The number of 'multiples' of floats to write
  multiple | The number of raw entries in each element to write, the default is 4 so count = 1 would write 4 floats.

## ◆ setNamedConstant() [9/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | const Vector2 & | vec )

Sets a Vector2 parameter to the program.

Parameters

  name | The name of the parameter
  vec | The value to set

## ◆ setNamedConstant() [10/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | const Vector3 & | vec )

Sets a Vector3 parameter to the program.

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  index | The index at which to place the parameter NB this index refers to the number of floats, so a Vector3 is 3. Note that many rendersystems & programs assume that every floating point parameter is passed in as a vector of 4 items, so you are strongly advised to check with RenderSystemCapabilities before using this version - if in doubt use Vector4 or ColourValue instead (both are 4D).
  vec | The value to set

## ◆ setNamedConstant() [11/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | const Vector4 & | vec )

Sets a single value constant boolean parameter to the program.

Remarks
  Different types of GPU programs support different types of constant parameters. For example, it's relatively common to find that vertex programs only support floating point constants, and that fragment programs only support integer (fixed point) parameters. This can vary depending on the program version supported by the graphics card being used. You should consult the documentation for the type of low level program you are using, or alternatively use the methods provided on RenderSystemCapabilities to determine the options.

  Another possible limitation is that some systems only allow constants to be set on certain boundaries, e.g. in sets of 4 values for example. Again, see RenderSystemCapabilities for full details.

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  val | The value to set Sets a Vector4 parameter to the program.
  name | The name of the parameter
  vec | The value to set

## ◆ setNamedConstant() [12/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | int | val )

Sets a single value constant integer parameter to the program.

Remarks
  Different types of GPU programs support different types of constant parameters. For example, it's relatively common to find that vertex programs only support floating point constants, and that fragment programs only support integer (fixed point) parameters. This can vary depending on the program version supported by the graphics card being used. You should consult the documentation for the type of low level program you are using, or alternatively use the methods provided on RenderSystemCapabilities to determine the options.

  Another possible limitation is that some systems only allow constants to be set on certain boundaries, e.g. in sets of 4 values for example. Again, see RenderSystemCapabilities for full details.

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  val | The value to set

## ◆ setNamedConstant() [13/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | Real | val )

Sets a single value constant floating-point parameter to the program.

Remarks
  Different types of GPU programs support different types of constant parameters. For example, it's relatively common to find that vertex programs only support floating point constants, and that fragment programs only support integer (fixed point) parameters. This can vary depending on the program version supported by the graphics card being used. You should consult the documentation for the type of low level program you are using, or alternatively use the methods provided on RenderSystemCapabilities to determine the options.

  Another possible limitation is that some systems only allow constants to be set on certain boundaries, e.g. in sets of 4 values for example. Again, see RenderSystemCapabilities for full details.

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  val | The value to set

## ◆ setNamedConstant() [14/14]

void Ogre::GpuProgramParameters::setNamedConstant | ( | const String & | name,
|  | uint | val )

Sets a single value constant unsigned integer parameter to the program.

Remarks
  Different types of GPU programs support different types of constant parameters. For example, it's relatively common to find that vertex programs only support floating point constants, and that fragment programs only support integer (fixed point) parameters. This can vary depending on the program version supported by the graphics card being used. You should consult the documentation for the type of low level program you are using, or alternatively use the methods provided on RenderSystemCapabilities to determine the options.

  Another possible limitation is that some systems only allow constants to be set on certain boundaries, e.g. in sets of 4 values for example. Again, see RenderSystemCapabilities for full details.

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  val | The value to set

## ◆ setNamedConstantFromTime()

void Ogre::GpuProgramParameters::setNamedConstantFromTime | ( | const String & | name,
|  | Real | factor )

Sets a named parameter up to track a derivation of the current time.

Note
  This named option will only work if you are using a parameters object created from a high-level program (HighLevelGpuProgram).

Parameters

  name | The name of the parameter
  factor | The amount by which to scale the time value

## ◆ setNamedSubroutine()

void Ogre::GpuProgramParameters::setNamedSubroutine | ( | const String & | subroutineSlot,
|  | const String & | subroutine )

Set subroutine name by slot name.

## ◆ setSubroutine()

void Ogre::GpuProgramParameters::setSubroutine | ( | size_t | index,
|  | const String & | subroutine )

Set subroutine name by slot index.

## ◆ setTransposeMatrices()

void Ogre::GpuProgramParameters::setTransposeMatrices | ( | bool | val | ) |
| inline

Sets whether or not we need to transpose the matrices passed in from the rest of OGRE.

Remarks
  D3D uses transposed matrices compared to GL and OGRE; this is not important when you use programs which are written to process row-major matrices, such as those generated by Cg, but if you use a program written to D3D's matrix layout you will need to enable this flag.

The documentation for this class was generated from the following file:

- OgreGpuProgramParams.h